package geniusweb.javavenv;

import java.io.File;
import java.io.IOException;

/**
 * Contains a Python Venv for a specific python tar.gz file. Requires the global
 * variable PYTHON3 pointing to python3.exe file.
 *
 */
public class VenvWithFile {
	private final File tgzfile; // the tgz file to be pip instaalled

	/**
	 * 
	 * @param tgzfile the tgzfile that needs to be <code>pip install</code>ed in
	 *                a python venv.
	 * @throws IOException
	 */
	public VenvWithFile(File tgzfile) throws IOException {
		if (tgzfile == null || !tgzfile.exists())
			throw new IllegalArgumentException(
					"tgzfile " + tgzfile + " must exist");
		if (!tgzfile.canRead())
			throw new IllegalArgumentException(
					"tgzfile " + tgzfile + " must be readable");

		this.tgzfile = tgzfile;
		String dirname = tgzfile.getName();
		// remove .tar.gz or similar at the end.
		if (dirname.contains(".")) {
			dirname = dirname.substring(0, dirname.indexOf("."));
		}
		// remove bad chars
		dirname = dirname.replaceAll("\\W", "");

		dirname = "" + "_" + dirname;

	}

	/**
	 * Close the venv, release all resources. You can not use this PythonVenv
	 * after calling this anymore.
	 */
	public synchronized void close() {

	}

}